diff -crB rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRAppIdItem.java rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRAppIdItem.java
*** rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRAppIdItem.java	2011-12-19 11:21:55.000000000 -0800
--- rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRAppIdItem.java	2012-03-08 15:33:29.000000000 -0800
***************
*** 40,46 ****
  		 * @param pktTrackerIndex the packet tracker index
  		 * @param pktsReceived the packets received
  		 */
! 		public RDRAppIdItem(RDRName rdrName, PacketName packetName, int pktTrackerIndex, int pktsReceived) {
  			this.rdrName = rdrName;
  			this.packetName = packetName;
  			this.name = packetName.toString();
--- 40,46 ----
  		 * @param pktTrackerIndex the packet tracker index
  		 * @param pktsReceived the packets received
  		 */
! 		public RDRAppIdItem(RDRName rdrName, PacketName packetName, int pktTrackerIndex, int pktsReceived, int nextIndex) {
  			this.rdrName = rdrName;
  			this.packetName = packetName;
  			this.name = packetName.toString();
***************
*** 59,64 ****
--- 59,71 ----
  			this.pktsReserved = reserved;
  			//}
  			
+ 			System.out.printf("Packets index %d rec %d next %d \n", pktTrackerIndex,  pktsReceived,  nextIndex);
+ //			this.pktsReserved = pktsReceived;  // srm
+ 
+ 			if ( reserved == 0 ){
+ 				System.out.println("Set reserved");this.pktsReserved = pktsReceived;
+ 			}
+ 			
  			//this.pktsReserved = pktsReceived;
  			this.pktsReceived = pktsReceived;
  			
diff -crB rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRAppIdList.java rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRAppIdList.java
*** rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRAppIdList.java	2011-12-19 11:21:55.000000000 -0800
--- rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRAppIdList.java	2012-03-08 15:33:29.000000000 -0800
***************
*** 52,64 ****
  			this.appIdCount[p.getApplicationId()] += 1;
  		}
  		
! 		// build the AppIdItem list
  		Iterator<PacketName> pni = packetNames.iterator();
  		
  		while (pni.hasNext()) {
  			PacketName packetName = pni.next();
  			int appId = packetName.getAppId();
! 			RDRAppIdItem rdrItem = new RDRAppIdItem(rdrName, packetName, packetTrackerIndex(appId, packetTracker), this.appIdCount[appId]);
  			
  			rdrAppIdList.add(rdrItem);
  		}
--- 52,79 ----
  			this.appIdCount[p.getApplicationId()] += 1;
  		}
  		
! 		int[] trackerIndex = new int[packetNames.size()+1];
! 		// build quick look ahead array
  		Iterator<PacketName> pni = packetNames.iterator();
+ 		int trackIn=0;
+ 		while (pni.hasNext()) {
+ 			PacketName packetName = pni.next();
+ 			int appId = packetName.getAppId();
+ 			trackerIndex[trackIn]= packetTrackerIndex(appId, packetTracker);
+ 			trackIn++;
+ 		}
  		
+ 		// build the AppIdItem list
+ //		Iterator<PacketName>
+ 		pni = packetNames.iterator();
+ 		int index=1;
  		while (pni.hasNext()) {
  			PacketName packetName = pni.next();
+ 			
+ 			
  			int appId = packetName.getAppId();
! 			RDRAppIdItem rdrItem = new RDRAppIdItem(rdrName, packetName, packetTrackerIndex(appId, packetTracker), this.appIdCount[appId],trackerIndex[index]);
! 			index++;
  			
  			rdrAppIdList.add(rdrItem);
  		}
diff -crB rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRFileWriter.java rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRFileWriter.java
*** rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRFileWriter.java	2011-12-19 11:21:55.000000000 -0800
--- rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDRFileWriter.java	2012-03-08 15:33:29.000000000 -0800
***************
*** 2,12 ****
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
! */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
- 
- 
  import gov.nasa.gsfc.drl.rtstps.core.RtStpsException;
  import gov.nasa.gsfc.drl.rtstps.core.ccsds.Packet;
  
--- 2,10 ----
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
!  */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
  import gov.nasa.gsfc.drl.rtstps.core.RtStpsException;
  import gov.nasa.gsfc.drl.rtstps.core.ccsds.Packet;
  
***************
*** 16,46 ****
  import java.util.List;
  import java.util.UUID;
  
- 
- 
  public class RDRFileWriter {
! 	
  	private String tempFilename;
  	private String destPath;
! 	
  	// private List<RDRProduct> rdrProducts = new LinkedList<RDRProduct>();
  	private RDRCreateFile rdrFile;
! 	
! 	
  	private int orbit;
  	private Origin distributor;
  	private MissionName missionName;
  	private Origin datasetSource;
  	private PlatformShortName platformShortname;
! 	
! 	
! 	public RDRFileWriter(String destPath, 
! 						int orbit, 
! 						int rdrCount, 
! 						Origin distributor, 
! 						MissionName missionName, 
! 						Origin datasetSource, 
! 						PlatformShortName platformShortname) throws RtStpsException {
  		this.distributor = distributor;
  		this.missionName = missionName;
  		this.datasetSource = datasetSource;
--- 14,36 ----
  import java.util.List;
  import java.util.UUID;
  
  public class RDRFileWriter {
! 
  	private String tempFilename;
  	private String destPath;
! 
  	// private List<RDRProduct> rdrProducts = new LinkedList<RDRProduct>();
  	private RDRCreateFile rdrFile;
! 
  	private int orbit;
  	private Origin distributor;
  	private MissionName missionName;
  	private Origin datasetSource;
  	private PlatformShortName platformShortname;
! 
! 	public RDRFileWriter(String destPath, int orbit, int rdrCount,
! 			Origin distributor, MissionName missionName, Origin datasetSource,
! 			PlatformShortName platformShortname) throws RtStpsException {
  		this.distributor = distributor;
  		this.missionName = missionName;
  		this.datasetSource = datasetSource;
***************
*** 48,67 ****
  		this.orbit = orbit;
  		this.destPath = destPath;
  		tempFilename = UUID.randomUUID().toString() + ".h5";
! 			
  		rdrFile = new RDRCreateFile(destPath, tempFilename, rdrCount);
  	}
! 	
! 	
! 	public RDRFileWriter(Stats stats, 
! 			String destPath, 
! 			int orbit, 
! 			int rdrCount, 
! 			Origin distributor, 
! 			MissionName missionName, 
! 			Origin datasetSource, 
  			PlatformShortName platformShortname) throws RtStpsException {
! 		
  		this.distributor = distributor;
  		this.missionName = missionName;
  		this.datasetSource = datasetSource;
--- 38,51 ----
  		this.orbit = orbit;
  		this.destPath = destPath;
  		tempFilename = UUID.randomUUID().toString() + ".h5";
! 
  		rdrFile = new RDRCreateFile(destPath, tempFilename, rdrCount);
  	}
! 
! 	public RDRFileWriter(Stats stats, String destPath, int orbit, int rdrCount,
! 			Origin distributor, MissionName missionName, Origin datasetSource,
  			PlatformShortName platformShortname) throws RtStpsException {
! 
  		this.distributor = distributor;
  		this.missionName = missionName;
  		this.datasetSource = datasetSource;
***************
*** 73,176 ****
  		rdrFile = new RDRCreateFile(stats, destPath, tempFilename, rdrCount);
  	}
  
- 
  	public void put(Packet p) throws RtStpsException {
  		rdrFile.put(p);
  	}
  
- 
  	public void close(boolean hdfCleanup) throws RtStpsException {
! 		
  		Date creationDateAndTime = new Date();
  		// the top level attributes
  		writeAttributes(creationDateAndTime);
! 		
  		// close the rdr file...
  		rdrFile.close();
! 		
  		// clean up any leftover housekeeping
  		if (hdfCleanup) {
  			HDF5Util.cleanup();
  		}
! 		
  		// rename to the final file name
  		rename(creationDateAndTime);
  	}
- 	
- 	private void writeAttributes(Date creationDateAndTime) throws RtStpsException {
  
! 		rdrFile.writeAttributes(creationDateAndTime, distributor, this.missionName, this.datasetSource, platformShortname);
  
! 	}
  
  
  	private void rename(Date creationDateAndTime) throws RtStpsException {
  		File old = new File(destPath, tempFilename);
! 		
  		List<RDR> rdrs = rdrFile.getRDRs();
! 		//PDSDate d1 = rdrFile.getFirstDateTime();
! 		//PDSDate d2 = rdrFile.getLastDataTime();
! 		
  		Aggregate firstAgg = findFirstScienceWeightedAggregate(rdrs);
! 		
! 		// LPEATE seems to want the original data based times not the rounded/truncated times in the file name
! 		PDSDate temp1 = firstAgg.getBeginningDateTime();
! 		PDSDate d1 = new PDSDate(temp1.getOriginalPacketTime());
! 		
! 		//PDSDate temp2 = firstAgg.getEndingDateTime();
! 		//PDSDate d2 = new PDSDate(temp2.getOriginalPacketTime());
! 		
! 		//PDSDate d1 = firstAgg.getBeginningDateTime();
! 		
! 		// But this one is offset from it and so is not really a LPEATE or LeapDate
! 		// it's the same if you get the original time or not in other words.
! 		// That means we have to substract the leap time from it.
! 		PDSDate d2 = firstAgg.getEndingDateTime();
! 		
! 		
! 		
! 		if (rdrs == null) return;
! 		if (rdrs.size() <= 0) return;
! 		if ((d1 == null) || (d2 == null)) return;
! 		
! 		NPOESSFilename nfn = new NPOESSFilename(rdrs,
! 												d1,
! 												d2,
! 												creationDateAndTime,
! 												SpacecraftId.npp,
! 												orbit,
! 												Origin.nfts);
! 		
! 		String realFilename = nfn.toString();
! 		
! 
! 		File nnew = new File(destPath, realFilename);
! 		
! 		old.renameTo(nnew);
! 		
! 		createUserBlock(nnew);
  	}
- 	
  
  	// FIXME only supports either RDRs with "SCIENCE" in the name or the DIARY
! 	private Aggregate findFirstScienceWeightedAggregate(List<RDR> rdrs) throws RtStpsException {
  		List<RDR> sciRDRs = new LinkedList<RDR>();
  		RDR diaryRDR = null;
  		for (RDR rdr : rdrs) {
! 			String rdrNameStr = rdr.getRDRName().getRDRStringName();  // avoid toString w/RDRName
  			if (rdrNameStr.contains("SCIENCE")) {
  				sciRDRs.add(rdr);
  			} else if (rdrNameStr.contains("DIARY")) {
  				diaryRDR = rdr;
  			} else {
! 				throw new RtStpsException("No support for non-science/non-diary RDRs [" + rdrNameStr + "]");
  			}
  		}
! 		
  		if ((sciRDRs.size() <= 0) && (diaryRDR == null)) {
! 			throw new RtStpsException("No science/diary RDRs found -- unable to get first/last time for filename");			
  		}
! 	
  		Aggregate firstAggregate = null;
  		// if there are any science RDRs, use them...
  		if (sciRDRs.size() > 0) {
--- 57,164 ----
  		rdrFile = new RDRCreateFile(stats, destPath, tempFilename, rdrCount);
  	}
  
  	public void put(Packet p) throws RtStpsException {
  		rdrFile.put(p);
  	}
  
  	public void close(boolean hdfCleanup) throws RtStpsException {
! 
  		Date creationDateAndTime = new Date();
  		// the top level attributes
  		writeAttributes(creationDateAndTime);
! 
  		// close the rdr file...
  		rdrFile.close();
! 
  		// clean up any leftover housekeeping
  		if (hdfCleanup) {
  			HDF5Util.cleanup();
  		}
! 
  		// rename to the final file name
  		rename(creationDateAndTime);
  	}
  
! 	private void writeAttributes(Date creationDateAndTime)
! 			throws RtStpsException {
  
! 		rdrFile.writeAttributes(creationDateAndTime, distributor,
! 				this.missionName, this.datasetSource, platformShortname);
  
+ 	}
  
  	private void rename(Date creationDateAndTime) throws RtStpsException {
  		File old = new File(destPath, tempFilename);
! 
  		List<RDR> rdrs = rdrFile.getRDRs();
! 		// PDSDate d1 = rdrFile.getFirstDateTime();
! 		// PDSDate d2 = rdrFile.getLastDataTime();
! 
  		Aggregate firstAgg = findFirstScienceWeightedAggregate(rdrs);
! 
! 		if (firstAgg != null) {
! 
! 			// LPEATE seems to want the original data based times not the
! 			// rounded/truncated times in the file name
! 			PDSDate temp1 = firstAgg.getBeginningDateTime();
! 			PDSDate d1 = new PDSDate(temp1.getOriginalPacketTime());
! 
! 			// PDSDate temp2 = firstAgg.getEndingDateTime();
! 			// PDSDate d2 = new PDSDate(temp2.getOriginalPacketTime());
! 
! 			// PDSDate d1 = firstAgg.getBeginningDateTime();
! 
! 			// But this one is offset from it and so is not really a LPEATE or
! 			// LeapDate
! 			// it's the same if you get the original time or not in other words.
! 			// That means we have to substract the leap time from it.
! 			PDSDate d2 = firstAgg.getEndingDateTime();
! 
! 			if (rdrs == null)
! 				return;
! 			if (rdrs.size() <= 0)
! 				return;
! 			if ((d1 == null) || (d2 == null))
! 				return;
! 
! 			NPOESSFilename nfn = new NPOESSFilename(rdrs, d1, d2,
! 					creationDateAndTime, SpacecraftId.npp, orbit, Origin.nfts);
! 
! 			String realFilename = nfn.toString();
! 
! 			File nnew = new File(destPath, realFilename);
! 
! 			old.renameTo(nnew);
! 
! 			createUserBlock(nnew);
! 		}
  	}
  
  	// FIXME only supports either RDRs with "SCIENCE" in the name or the DIARY
! 	private Aggregate findFirstScienceWeightedAggregate(List<RDR> rdrs)
! 			throws RtStpsException {
  		List<RDR> sciRDRs = new LinkedList<RDR>();
  		RDR diaryRDR = null;
  		for (RDR rdr : rdrs) {
! 			String rdrNameStr = rdr.getRDRName().getRDRStringName(); // avoid
! 																		// toString
! 																		// w/RDRName
  			if (rdrNameStr.contains("SCIENCE")) {
  				sciRDRs.add(rdr);
  			} else if (rdrNameStr.contains("DIARY")) {
  				diaryRDR = rdr;
  			} else {
! 				throw new RtStpsException(
! 						"No support for non-science/non-diary RDRs ["
! 								+ rdrNameStr + "]");
  			}
  		}
! 
  		if ((sciRDRs.size() <= 0) && (diaryRDR == null)) {
! 			throw new RtStpsException(
! 					"No science/diary RDRs found -- unable to get first/last time for filename");
  		}
! 
  		Aggregate firstAggregate = null;
  		// if there are any science RDRs, use them...
  		if (sciRDRs.size() > 0) {
***************
*** 181,187 ****
  			// otherwise must be a non-null diary then right?
  			firstAggregate = diaryRDR.getAggregate();
  		}
! 		
  		return firstAggregate;
  	}
  
--- 169,175 ----
  			// otherwise must be a non-null diary then right?
  			firstAggregate = diaryRDR.getAggregate();
  		}
! 
  		return firstAggregate;
  	}
  
***************
*** 189,224 ****
  	private Aggregate findFirstAggregate(List<RDR> rdrs) {
  		Aggregate firstAgg = null;
  		long firstMicros = 0L;
! 		
  		for (RDR rdr : rdrs) {
  			Aggregate agg = rdr.getAggregate();
! 			
! 			long micros = agg.getBeginningDateTime().getMicrosSinceEpoch();
! 			
! 			if (firstMicros == 0L) {
! 				firstMicros = micros;
! 				firstAgg = agg;
! 			} else if (micros < firstMicros) {
! 				firstMicros = micros;
! 				firstAgg = agg;
  			}
  		}
  		return firstAgg;
  	}
  
- 
  	private void createUserBlock(File file) throws RtStpsException {
! 		
  		List<RDR> rdrs = rdrFile.getRDRs();
! 		
! 		if (rdrs == null) return;
! 		
! 		if (rdrs.size() <= 0) return;
! 		
! 		UserBlock userBlock = new UserBlock(MissionName.NPP, PlatformShortName.NPP, rdrs);
! 		
  		userBlock.write(file);
! 		
  		userBlock.close();
  	}
  
--- 177,216 ----
  	private Aggregate findFirstAggregate(List<RDR> rdrs) {
  		Aggregate firstAgg = null;
  		long firstMicros = 0L;
! 
  		for (RDR rdr : rdrs) {
  			Aggregate agg = rdr.getAggregate();
! 			if (agg != null) {
! 
! 				long micros = agg.getBeginningDateTime().getMicrosSinceEpoch();
! 
! 				if (firstMicros == 0L) {
! 					firstMicros = micros;
! 					firstAgg = agg;
! 				} else if (micros < firstMicros) {
! 					firstMicros = micros;
! 					firstAgg = agg;
! 				}
  			}
  		}
  		return firstAgg;
  	}
  
  	private void createUserBlock(File file) throws RtStpsException {
! 
  		List<RDR> rdrs = rdrFile.getRDRs();
! 
! 		if (rdrs == null)
! 			return;
! 
! 		if (rdrs.size() <= 0)
! 			return;
! 
! 		UserBlock userBlock = new UserBlock(MissionName.NPP,
! 				PlatformShortName.NPP, rdrs);
! 
  		userBlock.write(file);
! 
  		userBlock.close();
  	}
  
diff -crB rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDR.java rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDR.java
*** rt-stps-org/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDR.java	2011-12-19 11:21:55.000000000 -0800
--- rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/RDR.java	2012-03-08 15:33:29.000000000 -0800
***************
*** 186,192 ****
  		
  		Granule granule = Granule.factory(rap, 
  										1L,
! 										new GranuleId(SpacecraftId.npp, rap.getFirstTime(), 0 /** HACK **/, rap.getTimeSpan()),
  										LEOAFlag.Off,
  										DocumentName ,
  										rap.getPacketTypes(),
--- 186,192 ----
  		
  		Granule granule = Granule.factory(rap, 
  										1L,
! 										new GranuleId(SpacecraftId.npp, rap.getFirstTime(),rdrName),
  										LEOAFlag.Off,
  										DocumentName ,
  										rap.getPacketTypes(),
